InitSprite()
InitSprite3D()
InitKeyboard()
InitSound()
InitMovie()

;Procedure Collision
Procedure BoxKolli(X1,Y1,W1,H1,  X2,Y2,W2,H2)
  If X1<X2+W2 And X1+W1>X2
    If Y1<Y2+H2 And Y1+H1>Y2
    ProcedureReturn 1
    EndIf
  EndIf
ProcedureReturn 0
EndProcedure


#W=16
#H=16


;Leveldaten
Dim Feld(#W,#H)
Dim solid(#W,#H)
Dim coin(#W,#H)

solid(10,9)=1

For i=0 To 16 Step 1
 solid(i,11)=1
Next

For i=0 To 16 Step 1
 coin(i,10)=1
Next


;Screen
ExamineDesktops()
OpenWindow(0,0,0,1024,768,"Basic Ghost v1.1",#PB_Window_ScreenCentered | #PB_Window_SystemMenu)
OpenWindowedScreen(WindowID(0),0,0,1024,768,0,0,0)


;Sound
LoadSound(0,"sfx\jump.wav")

LoadSound(1,"sfx\coin.wav")

LoadSound(2,"sfx\pipe.wav")

LoadSound(3,"sfx\1-up.wav")

LoadSound(4,"sfx\gameover.wav")

LoadMovie(0,"sfx\music\background-1.mid")

;Jetzt brauchen wir noch ein paar Grafiken
LoadSprite(0,"gfx\player.bmp",0)
TransparentSpriteColor(0,RGB(1,1,1))

LoadSprite(1,"gfx\stone.bmp",0)
TransparentSpriteColor(1,$FFFFFF)

LoadSprite(3,"gfx\quest.bmp",0)
TransparentSpriteColor(3,$FFFFFF)

LoadSprite(4,"gfx\quest-overlapped.bmp",#PB_Sprite_Texture)

LoadSprite(5,"gfx\cloud-1.bmp",0)
TransparentSpriteColor(5,0)

LoadSprite(6,"gfx\stone-break.bmp",0)
TransparentSpriteColor(6,$FFFFFF)

LoadSprite(7,"gfx\cloud-2.bmp",0)
TransparentSpriteColor(7,0)

LoadSprite(8,"gfx\coin.bmp",0)
TransparentSpriteColor(8,$FFFFFF)

LoadSprite(9,"gfx\enemy.bmp",0)
TransparentSpriteColor(9,RGB(100,100,100))

LoadSprite(10,"gfx\pipe.bmp",0)
TransparentSpriteColor(10,$FFFFFF)

LoadSprite(11,"gfx\heart.bmp",0)
TransparentSpriteColor(11,$FFFFFF)

LoadSprite(12,"gfx\bush-1.bmp",0)
TransparentSpriteColor(12,$FFFFFF)

LoadSprite(13,"gfx\bush-2.bmp",0)
TransparentSpriteColor(13,$FFFFFF)

CreateSprite3D(1,4)

;Variables
Define.l PlayerX,PlayerY;Position
Define.f MoveX,MoveY
Define.b OnGround
Define.l EnemyX,EnemyY

PlayerW=SpriteWidth(0) ;Breite des Spielers
PlayerH=SpriteHeight(0);Hhe des Spielers

TileW=SpriteWidth(1) ;Breite eines Tiles
TileH=SpriteHeight(1);Hhe eines Tiles

life=100
coin=0

movie=0

EnemyY=670

PlayMovie(movie,WindowID(0))

Repeat
  
  Event= WindowEvent()  
  
  ExamineKeyboard()
  
    If KeyboardPushed(#PB_Key_Escape)  
    End
    EndIf
    
 
    MoveX=0
    MoveY+0.5
    
    EnemyX=EnemyX+1
    If EnemyX>1024
       EnemyX=0
    EndIf
    
    If KeyboardPushed(#PB_Key_Left)
    MoveX-5
    EndIf
    If KeyboardPushed(#PB_Key_Right)
    MoveX+5
    EndIf
   
    If OnGround
      If KeyboardPushed(#PB_Key_Space)
      MoveY=-15 ;Grerer Wert=Hherer Sprung
      PlaySound(0)
      EndIf
    EndIf
 
 

  ;Variables Player

  PlayerX+MoveX
  PlayerY+MoveY
  
  OnGround=0
  Hit=0
    
    
    ;***********Not Solid***********
    For x=0 To #W
      For y=0 To #H
        If Feld(x,y)=1 
          If BoxKolli(x*TileW,y*TileH,TileW,TileH,PlayerX,PlayerY,PlayerW,PlayerH) ;
            Feld(x,y)=0
            Hit=1
            If MoveY<0; 
            PlayerY=Y*TileH+TileH;Untere Seite
            ElseIf MoveY>0
            OnGround=1
            PlayerY=Y*TileH-PlayerH;Linke Seite
            EndIf
          EndIf
        EndIf
      Next y
    Next x
    If Hit=1
       MoveY=0
    EndIf

    
   ;++++++++++coin++++++++++
    For x=0 To #W
      For y=0 To #H
        If coin(x,y)=1 
          If BoxKolli(x*TileW,y*TileH,TileW,TileH,PlayerX,PlayerY,PlayerW,PlayerH) 
               coin(x,y)=0
               PlaySound(1)
               coin=coin+1
          EndIf
        EndIf
      Next y
    Next x
      
    
    ;***********Solid***********
     
    ;++++++++++player++++++++++
    
    For x=0 To #W
      For y=0 To #H
        If solid(x,y)=1 
          If BoxKolli(x*TileW,y*TileH,TileW,TileH,PlayerX,PlayerY,PlayerW,PlayerH) ;
             Hit=1
            If MoveY<0; 
            PlayerY=Y*TileH+TileH;Untere Seite
            ElseIf MoveY>0
            OnGround=1
            PlayerY=Y*TileH-PlayerH;Linke Seite
            EndIf
          EndIf
        EndIf
      Next y
    Next x
    If Hit=1
       MoveY=0
    EndIf
  

 
    ;**********Drawing**********
    SetFrameRate(75)
    ClearScreen(RGB(100,0,255))

    ;background (bushes)
    DisplayTransparentSprite(12,450,530)
    DisplayTransparentSprite(13,200,530)
    
    
    For x=0 To #W
      For y=0 To #H
        Select Feld(x,y)
          Case 0
          Case 1
          DisplayTransparentSprite(6,x*TileW,y*TileH)
        EndSelect
      Next y
    Next x 
    
    
    ;Draw not solid
    For x=0 To #W
      For y=0 To #H
        Select solid(x,y)
          Case 0
          Case 1
          DisplayTransparentSprite(1,x*TileW,y*TileH)
        EndSelect
      Next y
    Next x
    
    
    For x=0 To #W
      For y=0 To #H
        Select coin(x,y)
          Case 0
          Case 1
          DisplayTransparentSprite(8,x*TileW,y*TileH)
        EndSelect
      Next y
    Next x 
    

  ;++++++++++Display Sprites++++++++++
  DisplayTransparentSprite(0,PlayerX,PlayerY)
  
  DisplayTransparentSprite(3,800,580)
  
  DisplayTransparentSprite(5,280,340)
  
  DisplayTransparentSprite(7,700,150)
  
  DisplayTransparentSprite(9,EnemyX,EnemyY)
  
  DisplayTransparentSprite(10,448,641)
  
  DisplayTransparentSprite(11,720,550)
  
      
  
  Start3D()  
  Sprite3DQuality(#PB_Sprite3D_BilinearFiltering)
  
  DisplaySprite3D(1,800,580)
  RotateSprite3D(1,-1, #PB_Relative)
  
  Stop3D()
  
  
  StartDrawing(WindowOutput(0))
  
  DrawingMode(#PB_2DDrawing_Transparent)  
  DrawText(64,100,"coin: "+Str(coin))
  DrawText(200,100,"life: "+Str(life))
  
  StopDrawing()
    
  FlipBuffers()
 
    
  If SpritePixelCollision(0,PlayerX,PlayerY,3,800,650)=1
                    
       For i=0 To 16 Step 1
         Feld(i,11)=1
       Next
       
       For i=0 To 9 Step 1
         Feld(i,9)=1
       Next
       
       For i=0 To 9 Step 1
         Feld(i,3)=1
       Next
       
       For i=0 To 9 Step 1
         coin(i,10)=1
       Next
  EndIf
  
  
  
  If SpritePixelCollision(0,PlayerX,PlayerY,10,448,641)=1 
     
     If KeyboardPushed(#PB_Key_Right)
           PlaySound(2)
           PlayerX=448+SpriteWidth(10)
     EndIf
     
     If KeyboardPushed(#PB_Key_Left)
           PlaySound(2)
           PlayerX=448-SpriteWidth(0)
     EndIf
  EndIf
    
  
  If SpriteCollision(0,PlayerX,PlayerY,9,EnemyX,EnemyY)
     life=life-1
  If life=0
     StopMovie(movie)
     Delay(500)
     PlaySound(4)
     MessageRequester("Info","Game Over")
     End
  EndIf
  EndIf
  
  
  If SpritePixelCollision(0,PlayerX,PlayerY,11,720,550)=1
     life=life+5
     PlaySound(3)
    If life>100
       life=100
    EndIf     
  EndIf 
  
  
  If KeyboardReleased(#PB_Key_R)
     For i=0 To 16 Step 1
       Feld(i,11)=1
     Next
     
     PlayerX=0
     PlayerY=0
     MoveY=0
     Score=0
  EndIf
  
  If MovieStatus(movie) = 0
     PlayMovie(movie, WindowID(0))
  EndIf  
   
  If Event=#PB_Event_CloseWindow
     CloseWindow(0)
  EndIf

  
  Until Event=#PB_Event_CloseWindow
; IDE Options = PureBasic 4.41 (Windows - x64)
; CursorPosition = 163
; Folding = +
; EnableXP
; Executable = ..\Basic Ghost.exe